<template>
  <div class="beerForm">
    <form @submit.prevent="sendForm">
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Name</label>
        <div class="col-sm-4">
          <input v-model="beer.name" :style="textFormStyle(beer.name)" type="text" class="form-control" placeholder="Name of the beer" required>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Comment</label>
        <div class="col-sm-4">
          <textarea v-model="beer.comment" class="form-control"></textarea>
        </div>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Price HT</label>
        <div class="col-sm-4">
         <input v-model.number="beer.priceHT" :style="numberFormStyle(beer.priceHT)" type="number" min="0" step="0.01"
         class="form-control" required>
        </div>
        <span>€</span>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Price TTC</label>
        <div class="col-sm-4">
          <PriceTTCtoHT
            v-model.number = "beer.priceHT"
            :isEditable = "true"
            @updatePriceHt = "updatePriceHt"
          />
        </div>
        <span>€</span>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Alcohol degree</label>
        <div class="col-sm-4">
         <input v-model.number="beer.alcoholDegree" :style="numberFormStyle(beer.alcoholDegree)"
         type="number" min="0" max="70" step="0.1" class="form-control" placeholder="0.0" required>
        </div>
        <span>°</span>
      </div>
      <div class="form-group row">
        <label class="col-sm-2 col-form-label">Type</label>
        <div class="col-sm-4">
          <select v-model="beer.type" :style="textFormStyle(beer.type)" class="form-control" required>
            <option v-for="type in beerTypes" :key="type" :value="type">
              {{ type }}
            </option>
          </select>
        </div>
      </div>
      <div class="form-group row">
          <button class="btn btn-primary" type="button" id="btnCancel" @click="cancel" >CANCEL</button>
          <button class="btn btn-primary" type="submit" >VALIDATE</button>
      </div>
    </form>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import PriceTTCtoHT from '@/components/PriceTTCtoHT.vue'
import apiRest from '@/api/apiRest'

export default {
  name: 'BeerForm',
  components: {
    PriceTTCtoHT
  },
  data () {
    return {
      beer: {
        priceHT: 0
      },
      beerTypes: [],
      modeUpdate: false
    }
  },
  methods: {
    textFormStyle (string) {
      return string == null ? 'border-color: red' : 'border-color: green'
    },
    numberFormStyle (number) {
      return (number == null || number < 0) ? 'border-color: red' : 'border-color: green'
    },
    async sendForm () {
      /* Méthode 1 : permet la copie mais pas en profondeur, si tu as des objets imbriqués, ils auront toujours la même
        const newBeer = Object.assign({}, this.beer)
        Méthode 2 : permet la copie en profondeur, mais pas si il y a des références cycliques, et c'est très couteux en perf
        const newBeer = JSON.parse(JSON.stringify(this.beer))
      */
      const newBeer = JSON.parse(JSON.stringify(this.beer))
      try {
        if (!this.modeUpdate) {
          const response = await apiRest.addBeer(this.$store.getters.getUser, newBeer)
          this.$toasted.success(`Beer ${response.data.name} added !`, { icon: { name: 'beer', after: true } })
          this.$router.push('/')
        } else {
          const response = await apiRest.updateBeer(newBeer)
          this.modeUpdate = false
          this.$store.commit('resetSelectedBeer')
          this.$toasted.success(`Beer ${response.data.name} updated !`, { icon: { name: 'beer', after: true } })
          this.$router.push('/')
        }
      } catch {
        if (!this.modeUpdate) {
          this.$toasted.error(`Unable to add the beer named ${newBeer.name}`, { icon: { name: 'times', after: true } })
        } else {
          this.$toasted.error(`Unable to update the beer named ${newBeer.name}`, { icon: { name: 'times', after: true } })
        }
      }
    },
    cancel () {
      this.$store.commit('resetSelectedBeer')
      this.$router.push('/')
    },
    updatePriceHt (price) {
      this.beer.priceHT = parseFloat(price).toFixed(2)
      this.beer.priceTTC = this.beer.priceHT * 1.2
    },
    async getBeerTypes () {
      try {
        const response = await apiRest.getBeerTypes()
        this.beerTypes = response.data
      } catch {
        this.$toasted.error('Unable to get beer types', { icon: { name: 'times', after: true } })
      }
    }
  },
  computed: {
    ...mapGetters({
      selectedBeer: 'getSelectedBeer'
    })
  },
  filters: {
    currency (value) {
      return (isNaN(value) || value < 0.0) ? '' : `${parseFloat(value).toFixed(2)}€`
    }
  },
  mounted () {
    this.getBeerTypes()
    if (this.selectedBeer) {
      this.beer = this.selectedBeer
      this.modeUpdate = true
    }
  }
}
</script>

<style scoped>
  #btnCancel {
    margin-left: 2%;
    margin-right: 25%;
    background-color:firebrick;
    border-color: darkslategrey;
  }
</style>
